#!/usr/bin/perl -w

package GUI::ErrorHandler;

use Data::Dumper;
use Exporter;
use Gtk2;
use Glib ':constants';
use Gtk2::GladeXML; 

@ISA=qw/Exporter/;

sub new{
	my ($pkgname,$glade)=@_;
	my $self={};
	bless $self;
	return $self;
}

#displays a nice dialog on warn()
sub doError{
	#print STDOUT Dumper @_;
	my ($msg,$fmsg,$level,$eval,$iline, $ifile, $oline, $ofile, $oscope) = @_;
	
	#omit all errors generated by Gtk2-Perl bindings
	if ($msg=~/^Gtk-CRITICAL \*\*\:/){next;}
	if ($msg=~/^GLib-GObject-CRITICAL \*\*\:/){next;}
	
	if($eval) {
		# if we are in an eval, skip to the next handler
		next;
	} else {
		# show a message box describing the error.
		my $glade=Gtk2::GladeXML->new("glade/puniconf.glade",'error_win');
		my $dlg=$glade->get_widget('error_win');
		my $txtbox=$glade->get_widget('error_text_view');
		$glade->get_widget('error_win_ok')->grab_focus();
		$glade->get_widget('error_win_ok')->
			signal_connect(
				clicked=>sub{ $dlg->destroy() }
			);
				
		$txtbox->get_buffer->insert($txtbox->get_buffer->get_start_iter,$msg);
		$dlg->show_all;

		next;
	}
};
#displays a nice dialog on die() and does not quit.
#NOTE:there are no die() method calls in the main puniconf program
sub dieError{
	#print STDOUT Dumper @_;
	my @in=@_;
	my ($msg,$fmsg,$level,$eval,$iline, $ifile, $oline, $ofile, $oscope) = @in;
	shift @in;shift @in;
	$msg.="\nPlease do not use die() in your plugins!";
	$fmsg.="\nPlease do not use die() in your plugins!";
	# show a message box describing the error.
	doError($msg,$fmsg,@in);
};


1;
