#!/usr/bin/perl -w

package GUI::HelpWindow;
#use ::puniconf;
use Exporter;
use Gtk2;
use Glib ':constants';
#use puniconf;

@ISA=qw/Exporter Gtk2::Window/;

sub new{
	my ($pkgname,$glade)=@_;
	my $self={};

	$self=$glade->get_widget('help_win');

	$glade->signal_autoconnect_from_package('help_win');

	$self->signal_connect ('destroy-event' => sub{
									$self->hide_all;
									return 1;
									});
	$self->signal_connect ('delete-event' => sub{
									$self->hide_all;
									return 1;
									});
	$glade->get_widget('help_win_close_btn')->signal_connect(clicked=>sub{$self->hide_all;});

	$self->{plugslist}=Gtk2::TreeStore->new ('Glib::String');
	$self->{plugsview}=$glade->get_widget('help_items_list');
	$self->{plugsview}->set_model($self->{plugslist});
	$self->{plugsview}->get_selection->set_mode ('single');
	$self->{plugsview}->get_selection->signal_connect(
							changed=>sub{get_help($self,@_);});
	add_columns($self->{plugsview});
	setup_list($self->{plugsview});
	
	$glade->get_widget('help_text_view')->set_buffer(puniconf::getBuffer);
	$self->{text} = $glade->get_widget('help_text_view')->get_buffer;

	#fbconfig::err(Dumper($self));
	bless $self;
	return $self;
}

################ Window ################
#	$self=new Gtk2::Window('toplevel');
#	$self->set_title("Help");
#	$self->set_default_size (400, 400);
#	$self->signal_connect ('destroy-event' => sub{
#									$self->hide_all;
#									return 1;
#									});
#	$self->signal_connect ('delete-event' => sub{
#									$self->hide_all;
#									return 1;
#									});
#
#
################ Left Pane ################
#	$self->{plugslist}=Gtk2::TreeStore->new ('Glib::String');
#	$self->{plugsview}=Gtk2::TreeView->new( $self->{plugslist} );
#	$self->{plugsview}->set_rules_hint (TRUE);
#	$self->{plugsview}->get_selection->set_mode ('single');
#	$self->{plugsview}->get_selection->signal_connect(
#							changed=>sub{get_help($self,@_);});
#	add_columns($self->{plugsview});
#	setup_list($self->{plugsview});
#	my $left = Gtk2::ScrolledWindow->new (undef, undef);
#	$left->set_shadow_type ('etched-in');
#	$left->set_policy ('automatic', 'automatic');
#	$left->add ($self->{plugsview});
#
################ Right Pane ################
#	$self->{tview}=new Gtk2::TextView;
#	$self->{tview}->set_editable(0);
#	$self->{tview}->set_buffer(puniconf::getBuffer);
#	$self->{tview}->set_wrap_mode('word');
#	$self->{tview}->set_size_request(300,-1);
#	$self->{text} = $self->{tview}->get_buffer;
#
#	my $right = Gtk2::ScrolledWindow->new (undef, undef);
#	$right->set_shadow_type ('etched-in');
#	$right->set_policy ('automatic', 'automatic');
#	$right->add ($self->{tview});
#
################ HPane ################
#	$hpaned = Gtk2::HPaned->new;
#	$hpaned->set_border_width (5);
#	$hpaned->add1($left);
#	$hpaned->add2($right);
#
#	$self->add($hpaned);
#	bless $self;
#	return $self;
#}
sub add_columns {
	my $view=shift;
	my $renderer = Gtk2::CellRendererText->new;
	$view->append_column (
  					Gtk2::TreeViewColumn->new_with_attributes (
										"Plugin", $renderer,text => 0
										)
									);

}

sub setup_list{
	my $view=shift;
	my $model=$view->get_model();

	foreach $m (<plugins/*.pm>){
		$m=~/plugins\/(.*).pm/;
		$mname=$1;
		my $iter = $model->append(undef);
		$model->set ($iter,
				0=>$mname,
				);
	}
}


sub get_help{
	my ($self,$selection)=@_;
	#warn 'getting help...';
	my $treeview = $selection->get_tree_view;
	my ($model, $iter) = $selection->get_selected;
	$self->{text}->delete($self->{text}->get_bounds());
	if ($iter && $model){
		my $mname=$model->get($iter,0);
		#warn 'for '.$mname;
		eval($mname.'->getHelp($self->{text});');
		warn $@ if $@;
	}
}
1;
