#!/usr/bin/perl -w

package GUI::Menu;

use Data::Dumper;
use Exporter;
use Gtk2;
use Glib ':constants';

@ISA=qw/Exporter Gtk2::MenuBar/;

sub new{
	#warn Dumper @_;
	my ($pkgname,$glade)=@_;
	my $self={};
	$self=$glade->get_widget('main_menu');

	#have to hand code 'activate' signal handler, because of bug in GladeXML
	#	which calls 'activate' signal handler three times when user selects item

	$glade->get_widget('file_open_menu_item')->signal_connect (activate => sub{puniconf::doOpenItem()});
	$glade->get_widget('file_save_menu_item')->signal_connect (activate => sub{puniconf::doSaveItem()});
	$glade->get_widget('file_quit_menu_item')->signal_connect (activate => sub{puniconf::quit()});

	$glade->get_widget('edit_prefs_menu_item')->signal_connect (activate => sub{puniconf::showPrefs()});

	$glade->get_widget('help_outputwin_menu_item')->signal_connect (activate =>
			sub{puniconf::showErr});
	$glade->get_widget('help_info_menu_item')->signal_connect (activate => sub{puniconf::showAbout()});
	$glade->get_widget('help_help_menu_item')->signal_connect (activate =>
					sub{puniconf::getHelpWindow->show_all()});

	$plugins = $glade->get_widget('plugin_mnu');
		$self->{plugmnu} = Gtk2::Menu->new;
		$plugins->set_submenu ($self->{plugmnu});

	bless $self;
	return $self;
}

sub addPlugMenu{
	#warn Dumper @_;
	my ($self,$title,$menu)=@_;
	$title=$title || 'Plugin Menu';
	my $newmnu = Gtk2::MenuItem->new_with_mnemonic ("$title");
		$newmnu->set_submenu ($menu);

	$newmnu->show_all();
	$self->{plugmnu}->append($newmnu);
}


1;
