#!/usr/bin/perl -w

package GUI::OutputWindow;
#use ::puniconf;
use Exporter;
use Gtk2;
use Glib ':constants';
#use puniconf;

@ISA=qw/Exporter Gtk2::Window/;

sub new{
	#warn Dumper @_;
	my ($pkgname,$glade)=@_;
	my $self={};
	$self=$glade->get_widget('output_win');
	$glade->signal_autoconnect_from_package('output_win');
	$self->signal_connect ('destroy-event' => sub{
									$self->hide_all;
									return 1;
									});
	$self->signal_connect ('delete-event' => sub{
									$self->hide_all;
									return 1;
									});


	$self->{tview}=$glade->get_widget('output_win_textview');
	$self->{text} = $self->{tview}->get_buffer;

	my $clearbtn=$glade->get_widget('output_win_clear_btn');
	$clearbtn->signal_connect (clicked => sub{
									$self->clear();
									});
	my $closebtn=$glade->get_widget('output_win_close_btn');
	$closebtn->signal_connect (clicked => sub{
									$self->hide_all;
									});

	bless $self;
	return $self;
}

sub add{
	my ($self,$text,$tag)=@_;
	my $buffer=$self->{text};
	my $iter = $buffer->get_end_iter;
	$buffer->insert_with_tags_by_name($iter,$text."\n",$tag) if $tag;
	$buffer->insert($iter,$text."\n") unless $tag;
}

sub clear{
	my $self=shift;
	$self->{text}->delete($self->{text}->get_bounds());
}


1;
