#!/usr/bin/perl -w

package GUI::PrefsWindow;

use Exporter;
use Gtk2;
use Glib ':constants';


@ISA=qw/Exporter Gtk2::Window/;

sub new{
	#warn Dumper @_;
	my ($pkgname,$glade)=@_;
	my $self={};
	$self=$glade->get_widget('prefs_win');
	$glade->signal_autoconnect_from_package('prefs_win');

############### Window ################
	$self->signal_connect ('destroy-event' => sub{
									$self->hide_all;
									return 1;
									});
	$self->signal_connect ('delete-event' => sub{
									$self->hide_all;
									return 1;
									});


############### Left Pane ################
	$self->{plugslist}=Gtk2::TreeStore->new ('Glib::Boolean','Glib::String');
	$self->{plugsview}=$glade->get_widget('prefs_win_pluginList');
	$self->{plugsview}->set_model($self->{plugslist});
	$self->{plugsview}->get_selection->set_mode ('single');
	$self->{plugsview}->get_selection->signal_connect(
							changed=>sub{get_help($self,@_);});
	add_columns($self->{plugsview});
	setup_list($self->{plugsview});

############### Right Pane ################
	$self->{tview}=$glade->get_widget('prefs_win_textview');
	$self->{tview}->set_buffer(puniconf::getBuffer);
	#$self->{tview}->set_size_request(300,-1);
	$self->{text} = $self->{tview}->get_buffer;

############### Buttons ################
	$glade->get_widget('prefs_win_cancel_btn')->signal_connect ('clicked' => sub{
									$self->hide_all;
									return 1;
									});
	
	$glade->get_widget('prefs_win_save_btn')->signal_connect ('clicked' => sub{
									$self->on_prefs_win_save_btn_clicked;
									});


	bless $self;
	return $self;
}
sub add_columns {
	my $view=shift;
	my $model=$view->get_model;
	my $renderer = Gtk2::CellRendererToggle->new;
	$renderer->signal_connect (toggled => \&fixed_toggled, $model);
	$view->append_column (
  					Gtk2::TreeViewColumn->new_with_attributes (
										"Active?", $renderer,active => 0
										)
									);
	$renderer = Gtk2::CellRendererText->new;
	$view->append_column (
  					Gtk2::TreeViewColumn->new_with_attributes (
										"Plugin", $renderer,text => 1
										)
									);

}

sub setup_list{
	my $view=shift;
	my $model=$view->get_model();

	foreach $m (<plugins/*.pm>){
		$m=~/plugins\/(.*).pm/;
		my $mname=$1;
		my $iter = $model->append(undef);
		$model->set ($iter,
				1=>$mname,
				);
	}
}


sub get_help{
	my ($self,$selection)=@_;
#	warn 'getting help...';
	my $treeview = $selection->get_tree_view;
	my ($model, $iter) = $selection->get_selected;
	$self->{text}->delete($self->{text}->get_bounds());
	if ($iter && $model){
		my $mname=$model->get($iter,1);
#		warn 'for '.$mname;
		eval($mname.'->getHelp($self->{text});');
		warn $@ if $@;
	}
}
sub fixed_toggled {
  my ($cell, $path_str, $model) = @_;
  my $path = Gtk2::TreePath->new ($path_str);

  # get toggled iter
  my $iter = $model->get_iter ($path);
  my ($fixed) = $model->get ($iter, 0);

  # do something with the value
  $fixed ^= 1;

  # set new value
  $model->set ($iter, 0, $fixed);
}

sub on_prefs_win_save_btn_clicked{
	my ($self)=@_;
	my $model=$self->{plugsview}->get_model;
	my $out='';
	my $iter=$model->get_iter_first;
	$out.='plugin='.$model->get($iter,1)."\n" if $model->get($iter,0);
	while ($iter=$model->iter_next($iter)){
		$out.='plugin='.$model->get($iter,1)."\n" if $model->get($iter,0);
	}
	#warn $out;
	if (open(PREFS,'>'.$ENV{'HOME'}."/.puniconf/prefs/puniprefs")){
		print PREFS $out;
		close PREFS;
	}else{
		warn "Could not open prefs file ".$ENV{'HOME'}."/.puniconf/prefs/puniprefs!";
	}

}


1;
