package GUI::TextBuffer;

use Gtk2;
use Glib ':constants';
use Data::Dumper;
use Gtk2::Pango;


@ISA=qw/Exporter Gtk2::TextBuffer/;

sub new{
	my $self=new Gtk2::TextBuffer(undef);
  $self->create_tag ("helpheading",
			weight => PANGO_WEIGHT_BOLD,
			size => 15 * PANGO_SCALE,
			underline => 'single',
			justification => 'center'
			);
   $self->create_tag ("helptopic",
			weight => PANGO_WEIGHT_BOLD,
			size => 12 * PANGO_SCALE,
			justification => 'left',
			background => "gray"
			);
   $self->create_tag ("helptopicbody",
			size => 10 * PANGO_SCALE,
			left_margin => 30,
			indent => 20
			);

  $self->create_tag ("italic", style => 'italic');
  $self->create_tag ("bold", weight => PANGO_WEIGHT_BOLD);
  $self->create_tag ("big", size => 20 * PANGO_SCALE);
			      # points times the PANGO_SCALE factor

  $self->create_tag ("xx-small", scale => PANGO_SCALE_XX_SMALL);
  $self->create_tag ("x-large", scale => PANGO_SCALE_X_LARGE);
  $self->create_tag ("mono", family => "monospace");
  $self->create_tag ("blue_foreground", foreground => "blue");
  $self->create_tag ("red_background", background => "red");

	my $stipple = Gtk2::Gdk::Bitmap->create_from_data (undef,pack('CC', 0x02, 0x01), 2,2);

  $self->create_tag ("background_stipple", background_stipple => $stipple);
  $self->create_tag ("foreground_stipple", foreground_stipple => $stipple);

  $self->create_tag ("big_gap_before_line", pixels_above_lines => 30);
  $self->create_tag ("big_gap_after_line", pixels_below_lines => 30);
  $self->create_tag ("double_spaced_line", pixels_inside_wrap => 10);
  $self->create_tag ("not_editable", editable => FALSE);
  $self->create_tag ("word_wrap", wrap_mode => 'word');
  $self->create_tag ("char_wrap", wrap_mode => 'char');
  $self->create_tag ("no_wrap", wrap_mode => 'none');
  $self->create_tag ("center", justification => 'center');
  $self->create_tag ("right_justify", justification => 'right');
  $self->create_tag ("wide_margins", left_margin => 50, right_margin => 50); 
  $self->create_tag ("strikethrough", strikethrough => TRUE); 
  $self->create_tag ("underline", underline => 'single');
  $self->create_tag ("double_underline", underline => 'double');

  $self->create_tag ("superscript",
			rise => 10 * PANGO_SCALE,	  # 10 pixels
			size => 8 * PANGO_SCALE,	  # 8 points
			);
  
  $self->create_tag ("subscript",
			rise => -10 * PANGO_SCALE,   # 10 pixels
			size => 8 * PANGO_SCALE,	   # 8 points
			);

	bless $self;
	return $self;

}
