#!/usr/bin/perl -w

package TestPlug2;

use Data::Dumper;
use Exporter;
use Gtk2;
use Glib ':constants';

@ISA=qw/Exporter Gtk2::Widget/;

sub new{
	my $self={};
	$self=new Gtk2::ScrolledWindow;
	$view=new Gtk2::TextView;
	$view->set_buffer(puniconf::getBuffer());
	my $buffer = $view->get_buffer;
	my $iter = $buffer->get_iter_at_offset (0);
	$buffer->insert_with_tags_by_name ($iter, "Welcome to ./puniconf!.\n",'helpheading');
	$buffer->insert_with_tags_by_name ($iter, "This is a sample Plugin.".
			" Use this module as a template for writing your own.\n".
			"The following demonstrates all of the tags you can use with the".
			" Gtk2::TextBuffer that is returned from the function ");
	$buffer->insert_with_tags_by_name ($iter, "puniconf::getBuffer().\n",'mono');
	$buffer->insert_with_tags_by_name ($iter, "helpheading\t",'helpheading');
	$buffer->insert_with_tags_by_name ($iter, "helptopic\t",'helptopic');
	$buffer->insert_with_tags_by_name ($iter, "helptopicbody\t",'helptopicbody');
	$buffer->insert_with_tags_by_name ($iter, "italic\t",'italic');
	$buffer->insert_with_tags_by_name ($iter, "bold\t",'bold');
	$buffer->insert_with_tags_by_name ($iter, "big\n",'big');
	$buffer->insert_with_tags_by_name ($iter, "xx-small\t",'xx-small');
	$buffer->insert_with_tags_by_name ($iter, "x-large\t",'x-large');
	$buffer->insert_with_tags_by_name ($iter, "mono\t",'mono');
	$buffer->insert_with_tags_by_name ($iter, "blue_foreground\t",'blue_foreground');
	$buffer->insert_with_tags_by_name ($iter, "red_background\n",'red_background');
	$buffer->insert_with_tags_by_name ($iter, "background_stipple (with red_background)\t",'background_stipple','red_background');
	$buffer->insert_with_tags_by_name ($iter, "foreground_stipple (with blue_foreground)\n",'foreground_stipple','blue_foreground');
	$buffer->insert_with_tags_by_name ($iter, "strikethrough\t",'strikethrough');
	$buffer->insert_with_tags_by_name ($iter, "underline\t",'underline');
	$buffer->insert_with_tags_by_name ($iter, "double_underline\t",'double_underline');
	$buffer->insert_with_tags_by_name ($iter, "superscript\t",'superscript');
	$buffer->insert_with_tags_by_name ($iter, "subscript\n",'subscript');
	$buffer->insert_with_tags_by_name ($iter, "big_gap_before_line\n",'big_gap_before_line');
	$buffer->insert_with_tags_by_name ($iter, "big_gap_after_line\n",'big_gap_after_line');
	$buffer->insert_with_tags_by_name ($iter, "double_spaced_line\n",'double_spaced_line');
	$buffer->insert_with_tags_by_name ($iter, "word_wrap\n",'word_wrap');
	$buffer->insert_with_tags_by_name ($iter, "char_wrap\n",'char_wrap');
	$buffer->insert_with_tags_by_name ($iter, "not_editable\n",'not_editable');
	$buffer->insert_with_tags_by_name ($iter, "no_wrap\n",'no_wrap');
	$buffer->insert_with_tags_by_name ($iter, "center\n",'center');
	$buffer->insert_with_tags_by_name ($iter, "right_justify\n",'right_justify');
	$buffer->insert_with_tags_by_name ($iter, "wide_margins\n",'wide_margins');

	$buffer->insert($iter,"===================================\n");
	$buffer->insert_with_tags_by_name ($iter, "Demo Plugin Usage\n",'helpheading');
	$buffer->insert_with_tags_by_name ($iter, "Generate Error.\n",'helptopic');
	$buffer->insert_with_tags_by_name ($iter, "You can generate an error to demonstrate the usage of die(), warn(), puniconf::err(),\nand puniconf::showStatus by pressing the toolbar button \"Error\" or by selecting the menu \n\'Plug-ins\'->\'TestPlug2\'->\'Generate Error\'.\n",'helptopicbody');

	$self->add($view);
	$self->show_all;
	bless $self;
	return $self;
}

sub getLabel{
	my $box=Gtk2::HBox->new(0,0);
	my $icon=Gtk2::Image->new_from_stock('gtk-preferences','menu');
	my $text=new Gtk2::Label("Test Plugin2");
	$box->pack_start($icon,0,0,0);
	$box->pack_start($text,0,0,0);
	$box->show_all;
		puniconf::addTip($text,'Just a demo...',undef);
		puniconf::showTips;
	return $box;
}

sub showHelp{
	puniconf::showStatus("This is where the help goes.");
}
sub Open{
	puniconf::showStatus("TestPlug2 Open...");
}
sub Save{
	puniconf::showStatus("TestPlug2 Save...");
}
sub Focus{
	puniconf::showStatus("TestPlug2 has the focus...");
}
sub setMenu{
	my $menu=puniconf::getMenu;
	my $plugmnu = Gtk2::Menu->new;
		my $aboutItem=Gtk2::MenuItem->new_with_mnemonic("Generate Error");
		$aboutItem->signal_connect (activate => sub{generateError()});
		$plugmnu->append($aboutItem);
		my $helpItem=Gtk2::MenuItem->new_with_mnemonic("TestPlug2 _Help...");
		$helpItem->signal_connect (activate => sub{doHelp()});
		$plugmnu->append($helpItem);

	$menu->addPlugMenu("TestPlug2",$plugmnu);
}

sub doAbout{
	puniconf::showStatus("TestPlug2 About...");
}
sub doHelp{
	puniconf::showStatus("TestPlug2 Help...");
}

sub getToolbarItems{
	my $newBtnToolTip='Generate an error';
	my $icon=Gtk2::Image->new_from_stock('gtk-execute','large-toolbar');
	warn 'Image cannot be created!' unless $icon;
	my $newBtn=Gtk2::ToolButton->new ($icon,'Error');
		$newBtn->signal_connect (clicked => sub{generateError()});
	puniconf::addTbItem($newBtn,$newBtnToolTip,$newBtnToolTip);

}
sub generateError{
	my $msg= "You have generated an error!";
	warn $msg;
	puniconf::showStatus($msg);
	puniconf::err($msg);
	#puniconf::showErr();
	die("Simple die()");
}


sub getIcon{
	my $icon=puniconf::getWindow->render_icon("gtk-preferences", "menu");
	return $icon;
}


sub getHelp{
	my ($self,$buffer)=@_;
	my $iter = $buffer->get_end_iter;

	$buffer->insert_with_tags_by_name ($iter, "A Simple Plugin\n", "helpheading");
	$buffer->insert_with_tags_by_name ($iter, "About\n", "helptopic");
	$buffer->insert_with_tags_by_name ($iter, "This plugin is just a demo plugin for puniconf.");


}





1;
