#!/usr/bin/perl -w

package cron;

use Data::Dumper;
use Exporter;
use Gtk2;
use Glib ':constants';

@ISA=qw/Exporter Gtk2::Widget/;

use constant COLUMN_JOB   => 0;
use constant COLUMN_PRODUCT  => 1;
use constant COLUMN_EDITABLE => 2;
use constant NUM_COLUMNS     => 3;


my $jobslist;
my $jobslistIter;
my $jobsview;
my $sEntry=new Gtk2::Entry;
my $mEntry=new Gtk2::Entry;
my $hEntry=new Gtk2::Entry;
my $timesEntry=new Gtk2::Entry;

sub new{
	my $self={};
	$self=new Gtk2::VBox;
	my $hpaned = Gtk2::HPaned->new;
	$hpaned->set_border_width (5);

	# create list store
	$jobslist = Gtk2::TreeStore->new ('Glib::String');

	$jobsview=Gtk2::TreeView->new($jobslist);
	$jobsview->set_rules_hint (TRUE);
	$jobsview->get_selection->set_mode ('single');

	listModel($jobsview,'Hello Wold', 'good-bye life');

	$renderer = Gtk2::CellRendererText->new;
	my $column = Gtk2::TreeViewColumn->new_with_attributes ("Job",
							  $renderer,text=>COLUMN_JOB);

	$jobsview->append_column ($column);

	$hpaned->add1 ($jobsview);


	$self->add ($hpaned);
	$self->show_all;
	bless $self;
	return $self;
}
sub add_columns {
  my $treeview = shift;
  my $model = $treeview->get_model;

  # number column
  my $renderer = Gtk2::CellRendererText->new;
  $renderer->signal_connect (edited => \&cell_edited, $model);
  $renderer->set_data (column => COLUMN_JOB);

  $treeview->new_with_attributes ("Number", $renderer,
					    text => COLUMN_JOB);

  # product column
  $renderer = Gtk2::CellRendererText->new;
  $renderer->signal_connect (edited => \&cell_edited, $model);
  $renderer->set_data (column => COLUMN_PRODUCT);

  $treeview->new_with_attributes (-1, "Product", $renderer,
					    text => COLUMN_PRODUCT);
}

sub listModel{
	#warn Dumper @_;
 my $view=shift;
	$jobslist=Gtk2::TreeStore->new ('Glib::String');
	my @d=@_;
	#$model->clear;
	#warn $model;
	# add data to the list store
	foreach $f (@d) {
		warn 'Adding '.$f;
		$jobslistIter = $jobslist->append(undef);
		$jobslist->set($jobslistIter, COLUMN_JOB=>$f);
	}
		warn Dumper $jobsview;
		warn Dumper $model;
		$jobsview->set_model($jobslist);

}

##################
#
#All methods below pertain to UI and events
#
##################
sub getLabel{
	my $box=Gtk2::HBox->new(0,0);
	my $icon=Gtk2::Image->new_from_stock('gtk-preferences','GTK_ICON_SIZE_MENU');
	my $text=new Gtk2::Label("CronConfig");
	my $closebtn=new
	$box->pack_start($icon,0,0,0);
	$box->pack_start($text,0,0,0);
	$box->show_all;
	return $box;
}

sub showHelp{
	::showStatus("This is where the help goes.");
}

#open the crontab file
sub Open{
listModel($jobsview,'another one...');
	my $file='';
	my $filesel=Gtk2::FileSelection->new('Select a cron file...');
	$filesel->set_filename('/etc/crontab');
	$filesel->show();
	$filesel->cancel_button->signal_connect(clicked=>sub{$filesel->destroy()});
	$filesel->ok_button->signal_connect(
						clicked=>sub{
								listModel($jobsview,'another one...');	#$filesel->get_filename());
								$filesel->destroy();
								});
	#warn Dumper $file;

}
sub Save{
	::showStatus("cron Save...");
}
sub Focus{
	::showStatus("cron has the focus...");
}
sub setMenu{
	my $menu=::getMenu;
	my $plugmnu = Gtk2::Menu->new;
		my $aboutItem=Gtk2::MenuItem->new_with_mnemonic("cron TestPlug2...");
		$aboutItem->signal_connect (activate => sub{doAbout()});
		$plugmnu->append($aboutItem);
		my $helpItem=Gtk2::MenuItem->new_with_mnemonic("cron _Help...");
		$helpItem->signal_connect (activate => sub{doHelp()});
		$plugmnu->append($helpItem);

	$menu->addPlugMenu("cron",$plugmnu);
}

sub doAbout{
	::showStatus("cron About...");
}
sub doHelp{
	::showStatus("cron Help...");
}

sub getToolbarItems{
	my $newBtnToolTip='Just a sample...';
	my $newBtnPrivateToolTip='Just a sample private...';
	#my $fakeTB=Gtk2::Toolbar->new;
	my $icon=Gtk2::Image->new_from_stock('gtk-preferences','GTK_ICON_SIZE_LARGE_TOOLBAR');
	warn 'Image cannot be created!' unless $icon;
	#$icon->show;
	my $newBtn=Gtk2::ToolButton->new (
					Gtk2::Image->new_from_stock('gtk-preferences','GTK_ICON_SIZE_LARGE_TOOLBAR'),
						'CronConfig');
		$newBtn->signal_connect (clicked => sub{ToolBtnClick()});
	::toolbarAdd($newBtn,$newBtnToolTip,$newBtnPrivateToolTip);

}
sub ToolBtnClick{
	::showStatus("cron Toolbar Button was clicked...");
}


sub getIcon{
	my $icon=::getWindow->render_icon("gtk-preferences", "menu");
	#warn Dumper $icon;
	return $icon;
}







1;
