#!/usr/bin/perl -w

package GRUBConf;

use Data::Dumper;

#test values
my @grubvals=('(hd1,10)','(hd2,0)','(hd0,0)','(scd9,9)','(fd1,10)','(fd0,0)','(hd3)');
my @devvals=('/dev/hdb5','/dev/hda','/dev/hda15','/dev/hdc153','/dev/fd0','/dev/scd5');

#used for letter <-> number conversions
my @letters=('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z');

#############################################
#for testing grub to dev
print "Testing grub values to /dev/* values...\n\n";
foreach $t (@grubvals){
	$t=~/\((\D*)(\d*)\,(\d*)\)/;
	my ($base,$drive,$part)=($1,$2,$3);
	my $retval="/dev/$base".$letters[$drive].($part+1);
	
	print "$t -> $retval\n";
	
}



#############################################


#############################################
#for testing dev to grub
print "Testing /dev/* values to grub values...\n\n";

foreach $t (@devvals){
	$t=~/(\/dev\/)(\D*)(\d*)/;
	my ($base,$drive,$part)=($1,$2,$3);
	my $drive2=substr($drive,-1,1,'');
	my $retval="($drive".findIndex(undef,\@letters,$drive2);
	$retval.=",".$part if $part;
	$retval.=")";
	
	print "$t -> $retval\n";
	
}
#finds the index where the passed element is located
sub findIndex{
	my ($self,$aref,$element)=@_;
	for(my $i=0;$i<@$aref;$i++){
		return $i if ( $aref->[$i] eq $element );
	}
	return -1;
}

#############################################
